diff --git a/bin/varnishd/cache/cache.h b/bin/varnishd/cache/cache.h
index 7147c23fba..3122c36934 100644
--- a/bin/varnishd/cache/cache.h
+++ b/bin/varnishd/cache/cache.h
@@ -1026,7 +1026,7 @@ const char *VCL_Return_Name(unsigned);
 
 #define VCL_MET_MAC(l,u,t,b) \
     void VCL_##l##_method(struct vcl *, struct worker *, struct req *, \
-	struct busyobj *bo, void *specific);
+	struct busyobj *bo, const struct cli *, void *specific);
 #include "tbl/vcl_returns.h"
 #undef VCL_MET_MAC
 
diff --git a/bin/varnishd/cache/cache_cli.c b/bin/varnishd/cache/cache_cli.c
index fa8aba80bb..dae96b4b5f 100644
--- a/bin/varnishd/cache/cache_cli.c
+++ b/bin/varnishd/cache/cache_cli.c
@@ -74,7 +74,7 @@ cli_cb_before(const struct cli *cli)
 
 	ASSERT_CLI();
 	VSL(SLT_CLI, 0, "Rd %s", cli->cmd);
-	VCL_Poll();
+	VCL_Poll(cli->ws);
 	VBE_Poll();
 	Lck_Lock(&cli_mtx);
 }
@@ -123,7 +123,9 @@ CLI_Init(void)
 	Lck_New(&cli_mtx, lck_cli);
 	cli_thread = pthread_self();
 
+	/* cli workspace same as size as client - no new knobs */
 	cls = VCLS_New(cli_cb_before, cli_cb_after,
+	    cache_param->workspace_client,
 	    &cache_param->cli_buffer, &cache_param->cli_limit);
 	AN(cls);
 	VCLS_Clone(cls, mgt_cls);
diff --git a/bin/varnishd/cache/cache_fetch.c b/bin/varnishd/cache/cache_fetch.c
index 405317c37a..0d54a5f6aa 100644
--- a/bin/varnishd/cache/cache_fetch.c
+++ b/bin/varnishd/cache/cache_fetch.c
@@ -267,7 +267,7 @@ vbf_stp_startfetch(struct worker *wrk, struct busyobj *bo)
 
 	http_PrintfHeader(bo->bereq, "X-Varnish: %u", VXID(bo->vsl->wid));
 
-	VCL_backend_fetch_method(bo->vcl, wrk, NULL, bo, NULL);
+	VCL_backend_fetch_method(bo->vcl, wrk, NULL, bo, NULL, NULL);
 
 	bo->uncacheable = bo->do_pass;
 	if (wrk->handling == VCL_RET_ABANDON)
@@ -430,7 +430,7 @@ vbf_stp_startfetch(struct worker *wrk, struct busyobj *bo)
 	bo->vfc->http = bo->beresp;
 	bo->vfc->esi_req = bo->bereq;
 
-	VCL_backend_response_method(bo->vcl, wrk, NULL, bo, NULL);
+	VCL_backend_response_method(bo->vcl, wrk, NULL, bo, NULL, NULL);
 
 	if (wrk->handling == VCL_RET_ABANDON) {
 		bo->htc->doclose = SC_RESP_CLOSE;
@@ -851,7 +851,7 @@ vbf_stp_error(struct worker *wrk, struct busyobj *bo)
 	synth_body = VSB_new_auto();
 	AN(synth_body);
 
-	VCL_backend_error_method(bo->vcl, wrk, NULL, bo, synth_body);
+	VCL_backend_error_method(bo->vcl, wrk, NULL, bo, NULL, synth_body);
 
 	AZ(VSB_finish(synth_body));
 
diff --git a/bin/varnishd/cache/cache_priv.h b/bin/varnishd/cache/cache_priv.h
index 415822c4d7..abf5019514 100644
--- a/bin/varnishd/cache/cache_priv.h
+++ b/bin/varnishd/cache/cache_priv.h
@@ -112,7 +112,7 @@ struct director *VCL_DefaultDirector(const struct vcl *);
 const struct vrt_backend_probe *VCL_DefaultProbe(const struct vcl *);
 void VCL_Init(void);
 void VCL_Panic(struct vsb *, const struct vcl *);
-void VCL_Poll(void);
+void VCL_Poll(struct ws *);
 
 /* cache_vrt.c */
 void VRTPRIV_init(struct vrt_privs *privs);
diff --git a/bin/varnishd/cache/cache_req_fsm.c b/bin/varnishd/cache/cache_req_fsm.c
index e7fec411ae..29e957fb7d 100644
--- a/bin/varnishd/cache/cache_req_fsm.c
+++ b/bin/varnishd/cache/cache_req_fsm.c
@@ -101,7 +101,7 @@ cnt_deliver(struct worker *wrk, struct req *req)
 	    !RFC2616_Req_Gzip(req->http))
 		RFC2616_Weaken_Etag(req->resp);
 
-	VCL_deliver_method(req->vcl, wrk, req, NULL, NULL);
+	VCL_deliver_method(req->vcl, wrk, req, NULL, NULL, NULL);
 	VSLb_ts_req(req, "Process", W_TIM_real(wrk));
 
 	/* Stop the insanity before it turns "Hotel California" on us */
@@ -172,7 +172,7 @@ cnt_synth(struct worker *wrk, struct req *req)
 	synth_body = VSB_new_auto();
 	AN(synth_body);
 
-	VCL_synth_method(req->vcl, wrk, req, NULL, synth_body);
+	VCL_synth_method(req->vcl, wrk, req, NULL, NULL, synth_body);
 
 	AZ(VSB_finish(synth_body));
 
@@ -405,7 +405,7 @@ cnt_lookup(struct worker *wrk, struct req *req)
 
 	VSLb(req->vsl, SLT_Hit, "%u", ObjGetXID(wrk, req->objcore));
 
-	VCL_hit_method(req->vcl, wrk, req, NULL, NULL);
+	VCL_hit_method(req->vcl, wrk, req, NULL, NULL, NULL);
 
 	switch (wrk->handling) {
 	case VCL_RET_DELIVER:
@@ -477,7 +477,7 @@ cnt_miss(struct worker *wrk, struct req *req)
 	AN(req->vcl);
 	CHECK_OBJ_NOTNULL(req->objcore, OBJCORE_MAGIC);
 
-	VCL_miss_method(req->vcl, wrk, req, NULL, NULL);
+	VCL_miss_method(req->vcl, wrk, req, NULL, NULL, NULL);
 	switch (wrk->handling) {
 	case VCL_RET_FETCH:
 		wrk->stats->cache_miss++;
@@ -518,7 +518,7 @@ cnt_pass(struct worker *wrk, struct req *req)
 	AN(req->vcl);
 	AZ(req->objcore);
 
-	VCL_pass_method(req->vcl, wrk, req, NULL, NULL);
+	VCL_pass_method(req->vcl, wrk, req, NULL, NULL, NULL);
 	switch (wrk->handling) {
 	case VCL_RET_SYNTH:
 		req->req_step = R_STP_SYNTH;
@@ -565,7 +565,7 @@ cnt_pipe(struct worker *wrk, struct req *req)
 	http_PrintfHeader(bo->bereq, "X-Varnish: %u", VXID(req->vsl->wid));
 	http_SetHeader(bo->bereq, "Connection: close");
 
-	VCL_pipe_method(req->vcl, wrk, req, bo, NULL);
+	VCL_pipe_method(req->vcl, wrk, req, bo, NULL, NULL);
 
 	switch (wrk->handling) {
 	case VCL_RET_SYNTH:
@@ -687,9 +687,9 @@ cnt_recv(struct worker *wrk, struct req *req)
 		}
 	}
 
-	VCL_recv_method(req->vcl, wrk, req, NULL, NULL);
+	VCL_recv_method(req->vcl, wrk, req, NULL, NULL, NULL);
 	if (wrk->handling == VCL_RET_VCL)
-		VCL_recv_method(req->vcl, wrk, req, NULL, NULL);
+		VCL_recv_method(req->vcl, wrk, req, NULL, NULL, NULL);
 
 	/* Attempts to cache req.body may fail */
 	if (req->req_body_status == REQ_BODY_FAIL) {
@@ -711,7 +711,7 @@ cnt_recv(struct worker *wrk, struct req *req)
 	}
 
 	SHA256_Init(&sha256ctx);
-	VCL_hash_method(req->vcl, wrk, req, NULL, &sha256ctx);
+	VCL_hash_method(req->vcl, wrk, req, NULL, NULL, &sha256ctx);
 	assert(wrk->handling == VCL_RET_LOOKUP);
 	SHA256_Final(req->digest, &sha256ctx);
 
@@ -780,7 +780,7 @@ cnt_purge(struct worker *wrk, struct req *req)
 
 	AZ(HSH_DerefObjCore(wrk, &boc, 1));
 
-	VCL_purge_method(req->vcl, wrk, req, NULL, NULL);
+	VCL_purge_method(req->vcl, wrk, req, NULL, NULL, NULL);
 	switch (wrk->handling) {
 	case VCL_RET_RESTART:
 		req->req_step = R_STP_RESTART;
diff --git a/bin/varnishd/cache/cache_vcl.c b/bin/varnishd/cache/cache_vcl.c
index 627b8c9aca..08a2ec95c1 100644
--- a/bin/varnishd/cache/cache_vcl.c
+++ b/bin/varnishd/cache/cache_vcl.c
@@ -41,6 +41,7 @@
 
 #include "vcl.h"
 #include "vrt.h"
+#include "vtim.h"
 
 #include "cache_director.h"
 #include "cache_backend.h"
@@ -680,6 +681,7 @@ VCL_Load(struct cli *cli, const char *name, const char *fn, const char *state)
 	ctx.method = VCL_MET_INIT;
 	ctx.handling = &hand;
 	ctx.vcl = vcl;
+	ctx.ws = cli->ws;
 
 	VSB_clear(vsb);
 	ctx.msg = vsb;
@@ -714,7 +716,7 @@ VCL_Load(struct cli *cli, const char *name, const char *fn, const char *state)
  */
 
 static void
-VCL_Nuke(struct vcl *vcl)
+VCL_Nuke(struct vcl *vcl, struct ws *ws)
 {
 	struct vrt_ctx ctx;
 	unsigned hand = 0;
@@ -729,6 +731,7 @@ VCL_Nuke(struct vcl *vcl)
 	ctx.method = VCL_MET_FINI;
 	ctx.handling = &hand;
 	ctx.vcl = vcl;
+	ctx.ws = ws;
 	vcl_failsafe_event(&ctx, VCL_EVENT_DISCARD);
 	vcl_KillBackends(vcl);
 	free(vcl->loaded_name);
@@ -740,7 +743,7 @@ VCL_Nuke(struct vcl *vcl)
 /*--------------------------------------------------------------------*/
 
 void
-VCL_Poll(void)
+VCL_Poll(struct ws *ws)
 {
 	struct vrt_ctx ctx;
 	struct vcl *vcl, *vcl2;
@@ -752,11 +755,12 @@ VCL_Poll(void)
 		    vcl->temp == VCL_TEMP_COOLING) {
 			INIT_OBJ(&ctx, VRT_CTX_MAGIC);
 			ctx.vcl = vcl;
+			ctx.ws = ws;
 			ctx.handling = &hand;
 			(void)vcl_set_state(&ctx, "0");
 		}
 		if (vcl->discard && vcl->temp == VCL_TEMP_COLD)
-			VCL_Nuke(vcl);
+			VCL_Nuke(vcl, ws);
 	}
 }
 
@@ -816,6 +820,7 @@ ccf_config_state(struct cli *cli, const char * const *av, void *priv)
 	AN(av[3]);
 	ctx.vcl = vcl_find(av[2]);
 	AN(ctx.vcl);			// MGT ensures this
+	ctx.ws = cli->ws;
 	if (vcl_set_state(&ctx, av[3]) == 0) {
 		bprintf(ctx.vcl->state, "%s", av[3] + 1);
 		VSB_destroy(&ctx.msg);
@@ -856,7 +861,7 @@ ccf_config_discard(struct cli *cli, const char * const *av, void *priv)
 		VTAILQ_REMOVE(&vcl_head, vcl, list);
 		free(vcl->loaded_name);
 	} else if (vcl->temp == VCL_TEMP_COLD)
-		VCL_Nuke(vcl);
+		VCL_Nuke(vcl, cli->ws);
 }
 
 static void __match_proto__(cli_func_t)
@@ -954,7 +959,7 @@ ccf_config_show(struct cli *cli, const char * const *av, void *priv)
 
 static void
 vcl_call_method(struct worker *wrk, struct req *req, struct busyobj *bo,
-    void *specific, unsigned method, vcl_func_f *func)
+    const struct cli *cli, void *specific, unsigned method, vcl_func_f *func)
 {
 	char *aws;
 	struct vsl_log *vsl = NULL;
@@ -962,6 +967,11 @@ vcl_call_method(struct worker *wrk, struct req *req, struct busyobj *bo,
 
 	CHECK_OBJ_NOTNULL(wrk, WORKER_MAGIC);
 	INIT_OBJ(&ctx, VRT_CTX_MAGIC);
+	if (cli != NULL) {
+		CHECK_OBJ_NOTNULL(cli, CLI_MAGIC);
+		ctx.ws = cli->ws;
+		ctx.now = VTIM_real();
+	}
 	if (req != NULL) {
 		CHECK_OBJ_NOTNULL(req, REQ_MAGIC);
 		CHECK_OBJ_NOTNULL(req->sp, SESS_MAGIC);
@@ -988,6 +998,7 @@ vcl_call_method(struct worker *wrk, struct req *req, struct busyobj *bo,
 		ctx.now = bo->t_prev;
 		ctx.ws = bo->ws;
 	}
+	WS_Assert(ctx.ws);
 	assert(ctx.now != 0);
 	ctx.vsl = vsl;
 	ctx.specific = specific;
@@ -1013,13 +1024,14 @@ vcl_call_method(struct worker *wrk, struct req *req, struct busyobj *bo,
 #define VCL_MET_MAC(func, upper, typ, bitmap)				\
 void									\
 VCL_##func##_method(struct vcl *vcl, struct worker *wrk,		\
-     struct req *req, struct busyobj *bo, void *specific)		\
+    struct req *req, struct busyobj *bo, const struct cli *cli,		\
+    void *specific)							\
 {									\
 									\
 	CHECK_OBJ_NOTNULL(vcl, VCL_MAGIC);				\
 	CHECK_OBJ_NOTNULL(vcl->conf, VCL_CONF_MAGIC);			\
 	CHECK_OBJ_NOTNULL(wrk, WORKER_MAGIC);				\
-	vcl_call_method(wrk, req, bo, specific,				\
+	vcl_call_method(wrk, req, bo, cli, specific,			\
 	    VCL_MET_ ## upper, vcl->conf->func##_func);			\
 	AN((1U << wrk->handling) & bitmap);				\
 }
diff --git a/bin/varnishd/mgt/mgt_cli.c b/bin/varnishd/mgt/mgt_cli.c
index b16597dd26..4eaa475646 100644
--- a/bin/varnishd/mgt/mgt_cli.c
+++ b/bin/varnishd/mgt/mgt_cli.c
@@ -349,6 +349,7 @@ mgt_cli_init_cls(void)
 {
 
 	mgt_cls = VCLS_New(mgt_cli_cb_before, mgt_cli_cb_after,
+	    mgt_param.workspace_client,
 	    &mgt_param.cli_buffer, &mgt_param.cli_limit);
 	AN(mgt_cls);
 	VCLS_AddFunc(mgt_cls, MCF_NOAUTH, cli_auth);
diff --git a/include/vcli_serve.h b/include/vcli_serve.h
index cfe42657fe..1ce918ccb7 100644
--- a/include/vcli_serve.h
+++ b/include/vcli_serve.h
@@ -32,6 +32,7 @@
  */
 
 #include "vcli.h"
+#include "ws.h"
 
 struct cli;	/* NB: struct cli is opaque at this level.  */
 struct vlu;
@@ -80,6 +81,7 @@ struct cli {
 	struct vlu              *vlu;
 	struct VCLS             *cls;
 	volatile unsigned       *limit;
+	struct ws		*ws;
 };
 
 /* The implementation must provide these functions */
@@ -92,7 +94,7 @@ void VCLI_SetResult(struct cli *cli, unsigned r);
 
 typedef void cls_cb_f(void *priv);
 typedef void cls_cbc_f(const struct cli*);
-struct VCLS *VCLS_New(cls_cbc_f *before, cls_cbc_f *after,
+struct VCLS *VCLS_New(cls_cbc_f *before, cls_cbc_f *after, size_t ws_sz,
     volatile unsigned *maxlen, volatile unsigned *limit);
 struct cli *VCLS_AddFd(struct VCLS *cs, int fdi, int fdo, cls_cb_f *closefunc,
     void *priv);
diff --git a/lib/libvarnish/vcli_serve.c b/lib/libvarnish/vcli_serve.c
index 80d09de62e..dbce54c489 100644
--- a/lib/libvarnish/vcli_serve.c
+++ b/lib/libvarnish/vcli_serve.c
@@ -76,6 +76,7 @@ struct VCLS {
 	volatile unsigned		*maxlen;
 	volatile unsigned		*limit;
 	struct cli_proto		*wildcard;
+	size_t				ws_sz;
 };
 
 /*--------------------------------------------------------------------*/
@@ -190,6 +191,7 @@ static void
 cls_dispatch(struct cli *cli, const struct cli_proto *cp,
     char * const * av, unsigned ac)
 {
+	char *ws_snap = NULL;
 	int json = 0;
 
 	AN(av);
@@ -222,10 +224,19 @@ cls_dispatch(struct cli *cli, const struct cli_proto *cp,
 
 	cli->result = CLIS_OK;
 	VSB_clear(cli->sb);
+
+	if (cli->ws)
+		ws_snap = WS_Snapshot(cli->ws);
+
 	if (json)
 		cp->jsonfunc(cli, (const char * const *)av, cp->priv);
 	else
 		cp->func(cli, (const char * const *)av, cp->priv);
+
+	if (ws_snap) {
+		WS_Assert(cli->ws);
+		WS_Reset(cli->ws, ws_snap);
+	}
 }
 
 /*--------------------------------------------------------------------
@@ -394,8 +405,8 @@ cls_vlu(void *priv, const char *p)
 }
 
 struct VCLS *
-VCLS_New(cls_cbc_f *before, cls_cbc_f *after, volatile unsigned *maxlen,
-    volatile unsigned *limit)
+VCLS_New(cls_cbc_f *before, cls_cbc_f *after, size_t ws_sz,
+    volatile unsigned *maxlen, volatile unsigned *limit)
 {
 	struct VCLS *cs;
 
@@ -407,6 +418,7 @@ VCLS_New(cls_cbc_f *before, cls_cbc_f *after, volatile unsigned *maxlen,
 	cs->after = after;
 	cs->maxlen = maxlen;
 	cs->limit = limit;
+	cs->ws_sz = ws_sz;
 	return (cs);
 }
 
@@ -428,6 +440,12 @@ VCLS_AddFd(struct VCLS *cs, int fdi, int fdo, cls_cb_f *closefunc, void *priv)
 	cfd->cli->vlu = VLU_New(cfd, cls_vlu, *cs->maxlen);
 	cfd->cli->sb = VSB_new_auto();
 	cfd->cli->limit = cs->limit;
+	if (cs->ws_sz > 0) {
+		cfd->cli->ws = malloc(sizeof(*cfd->cli->ws));
+		assert(cfd->cli->ws != NULL);
+		WS_Init(cfd->cli->ws, "cli",
+		    malloc(cs->ws_sz), cs->ws_sz);
+	}
 	cfd->closefunc = closefunc;
 	cfd->priv = priv;
 	AN(cfd->cli->sb);
